blob: f8099a98dbcbc6a45b042adf607ad4dbf143decf [file] [log] [blame]
Reid Spencer28b7c7f2006-11-09 00:26:17 +00001#!/bin/bash
2#
3# findmisopt
4#
5# This is a quick and dirty hack to potentially find a misoptimization
6# problem. Mostly its to work around problems in bugpoint that prevent
7# it from finding a problem unless the set of failing optimizations are
8# known and given to it on the command line.
9#
10# Given a bytecode file that produces correct output (or return code),
11# this script will run through all the optimizations passes that gccas
12# uses (in the same order) and will narrow down which optimizations
13# cause the program either generate different output or return a
14# different result code. When the passes have been narrowed down,
Reid Spencera8c3ff42006-11-16 18:32:47 +000015# bugpoint is invoked to further refine the problem to its origin. If a
16# release version of bugpoint is available it will be used, otherwise
17# debug.
Reid Spencer28b7c7f2006-11-09 00:26:17 +000018#
19# Usage:
20# findmisopt bcfile outdir progargs [match]
21#
22# Where:
23# bcfile
24# is the bytecode file input (the unoptimized working case)
25# outdir
26# is a directory into which intermediate results are placed
27# progargs
28# is a single argument containing all the arguments the program needs
Reid Spencera8c3ff42006-11-16 18:32:47 +000029# match
Reid Spencer28b7c7f2006-11-09 00:26:17 +000030# if specified to any value causes the result code of the program to
31# be used to determine success/fail. If not specified success/fail is
32# determined by diffing the program's output with the non-optimized
33# output.
34#
Reid Spencere4d8f332006-11-09 00:50:32 +000035if [ "$#" -lt 3 ] ; then
36 echo "usage: findmisopt bcfile outdir progargs [match]"
37 exit 1
38fi
39
Reid Spencera8c3ff42006-11-16 18:32:47 +000040dir="${0%%/utils/findmisopt}"
41if [ -x "$dir/Release/bin/bugpoint" ] ; then
42 bugpoint="$dir/Release/bin/bugpoint"
43elif [ -x "$dir/Debug/bin/bugpoint" ] ; then
44 bugpoint="$dir/Debug/bin/bugpoint"
45else
46 echo "findmisopt: bugpoint not found"
47 exit 1
48fi
49
Reid Spencer28b7c7f2006-11-09 00:26:17 +000050bcfile="$1"
51outdir="$2"
52args="$3"
53match="$4"
54name=`basename $bcfile .bc`
55ll="$outdir/${name}.ll"
56s="$outdir/${name}.s"
57prog="$outdir/${name}"
58out="$outdir/${name}.out"
59optbc="$outdir/${name}.opt.bc"
60optll="$outdir/${name}.opt.ll"
61opts="$outdir/${name}.opt.s"
62optprog="$outdir/${name}.opt"
63optout="$outdir/${name}.opt.out"
64
65echo "Test Name: $name"
66echo "Unoptimized program: $prog"
67echo " Optimized program: $optprog"
68
Reid Spencer02440992006-11-13 16:08:51 +000069# Create output directory if it doesn't exist
70if [ -f "$outdir" ] ; then
71 echo "$outdir is not a directory"
72 exit 1
73fi
74
75if [ ! -d "$outdir" ] ; then
76 mkdir "$outdir" || exit 1
77fi
Reid Spencer28b7c7f2006-11-09 00:26:17 +000078
79# Generate the disassembly
80llvm-dis "$bcfile" -o "$ll" -f || exit 1
81
82# Generate the non-optimized program
83llc "$bcfile" -o "$s" -f || exit 1
Reid Spencer2fe47fc2006-11-11 10:22:48 +000084gcc "$s" -o "$prog" -lstdc++ -lc -lm || exit 1
Reid Spencer28b7c7f2006-11-09 00:26:17 +000085
Reid Spencera8c3ff42006-11-16 18:32:47 +000086# Define the list of optimizations to run. This comprises the same set of
87# optimizations that gccas and gccld run, in the same order.
Reid Spencer5b31cf02006-11-18 17:14:09 +000088all_switches="-verify -lowersetjmp -funcresolve -raiseallocs -simplifycfg -mem2reg -globalopt -globaldce -ipconstprop -deadargelim -instcombine -simplifycfg -prune-eh -inline -simplify-libcalls -argpromotion -raise -tailduplicate -simplifycfg -scalarrepl -instcombine -predsimplify -condprop -tailcallelim -simplifycfg -reassociate -licm -loop-unswitch -instcombine -indvars -loop-unroll -instcombine -load-vn -gcse -sccp -instcombine -condprop -dse -dce -simplifycfg -deadtypeelim -constmerge -funcresolve -internalize -ipsccp -globalopt -constmerge -deadargelim -inline -prune-eh -globalopt -globaldce -argpromotion -instcombine -predsimplify -scalarrepl -globalsmodref-aa -licm -load-vn -gcse -dse -instcombine -simplifycfg -verify"
89# Here's an alternative list of optimizations comprising just the ones that
90# gccld uses. To use, just comment out the line above, and uncomment this one
91#all_switches="-funcresolve -internalize -ipsccp -globalopt -constmerge -deadargelim -inline -prune-eh -globalopt -globaldce -argpromotion -instcombine -predsimplify -scalarrepl -globalsmodref-aa -licm -load-vn -gcse -dse -instcombine -simplifycfg -verify"
Reid Spencer28b7c7f2006-11-09 00:26:17 +000092
93# Current set of switches is empty
94function tryit {
95 switches_to_use="$1"
96 opt $switches_to_use "$bcfile" -o "$optbc" -f || exit
97 llvm-dis "$optbc" -o "$optll" -f || exit
98 llc "$optbc" -o "$opts" -f || exit
Reid Spencer2fe47fc2006-11-11 10:22:48 +000099 gcc "$opts" -o "$optprog" -lstdc++ -lc -lm || exit
Reid Spencer02440992006-11-13 16:08:51 +0000100 "$prog" $args > "$out" 2>&1
Reid Spencer28b7c7f2006-11-09 00:26:17 +0000101 ex1=$?
Reid Spencer02440992006-11-13 16:08:51 +0000102 "$optprog" $args > "$optout" 2>&1
Reid Spencer28b7c7f2006-11-09 00:26:17 +0000103 ex2=$?
104
105 if [ -n "$match" ] ; then
106 if [ "$ex1" -ne "$ex2" ] ; then
107 echo "Return code not the same with these switches:"
108 echo $switches
109 echo "Unoptimized returned: $ex1"
110 echo "Optimized returned: $ex2"
111 return 0
112 fi
113 else
114 diff "$out" "$optout" > /dev/null
115 if [ $? -ne 0 ] ; then
116 echo "Diff fails with these switches:"
117 echo $switches
118 echo "Differences:"
Reid Spencerba07a692006-11-25 04:07:06 +0000119 diff "$out" "$optout" | head
Reid Spencer28b7c7f2006-11-09 00:26:17 +0000120 return 0;
121 fi
122 fi
123 return 1
124}
125
Reid Spencer02440992006-11-13 16:08:51 +0000126echo "Trying to find optimization that breaks program:"
Reid Spencer28b7c7f2006-11-09 00:26:17 +0000127for sw in $all_switches ; do
Reid Spencer02440992006-11-13 16:08:51 +0000128 echo -n " $sw"
Reid Spencer28b7c7f2006-11-09 00:26:17 +0000129 switches="$switches $sw"
130 if tryit "$switches" ; then
131 break;
132 fi
133done
134
Reid Spencer6d0fbd42006-11-22 03:46:45 +0000135# Terminate the previous output with a newline
136echo ""
137
138# Determine if we're done because none of the optimizations broke the program
139if [ "$switches" == " $all_switches" ] ; then
140 echo "The program did not miscompile"
141 exit 0
142fi
143
Reid Spencer28b7c7f2006-11-09 00:26:17 +0000144final=""
145while [ ! -z "$switches" ] ; do
146 trimmed=`echo "$switches" | sed -e 's/^ *\(-[^ ]*\).*/\1/'`
147 switches=`echo "$switches" | sed -e 's/^ *-[^ ]* *//'`
148 echo "Trimmed $trimmed from left"
149 tryit "$final $switches"
150 if [ "$?" -eq "0" ] ; then
151 echo "Still Failing .. continuing ..."
152 continue
153 else
154 echo "Found required early pass: $trimmed"
155 final="$final $trimmed"
156 continue
157 fi
158 echo "Next Loop"
159done
160
Reid Spencerdd2b9552006-11-09 01:47:04 +0000161if [ "$final" == " $all_switches" ] ; then
Reid Spencer02440992006-11-13 16:08:51 +0000162 echo "findmisopt: All optimizations pass. Perhaps this isn't a misopt?"
Reid Spencerdd2b9552006-11-09 01:47:04 +0000163 exit 0
164fi
165echo "Smallest Optimization list=$final"
Reid Spencera8c3ff42006-11-16 18:32:47 +0000166
167bpcmd="$bugpoint -run-llc -disable-loop-extraction --output "$out" --input /dev/null $bcfile $final --args $args"
Reid Spencer28b7c7f2006-11-09 00:26:17 +0000168
169echo "Running: $bpcmd"
170$bpcmd
Reid Spencerdd2b9552006-11-09 01:47:04 +0000171echo "findmisopt finished."